//= require <dSS/GetTextHelper>
//= require <dSS/config/Config>
//= require <dSS/util/TimeInfo>
Ext.namespace("dSS", "dSS.config");

dSS.overviewInit = function()
{
    dSS.config.dSSTimeDiff = 0;

    var viewport = new Ext.Viewport({
        layout: 'border',
        items: [
        {
            xtype: 'box',
            region: 'north',
            height: 70,
            // give north and south regions a height
            autoEl: {
                tag: 'div',
                html: '<a href="http://digitalstrom.org/" alt="' + dSS._("visit digitalSTROM.org") + '"><img id="logo" src="images/ds_logo.png" alt="dS-Logo"></a>' + '<h1><a href="http://digitalstrom.org/" alt="visit digitalSTROM.org">' + dSS._("digitalSTROM Server Overview") + '</a></h1>' + '<p><span id= \'dssVersion\'>-</span>, <span id=\'dssTime\'>-</span></p>'
            }
        },
        {
            region: 'center',
            xtype: 'panel',
            hideBorders: true,
            // TODO: fixme
            autoLoad: 'locale/de_DE/overview-links.html'
        }]
    });

    Ext.Ajax.request({
        url: "/json/system/version",
        disableCaching: true,
        success: function(response, options) {
            try {
                var data = Ext.decode(response.responseText);
                if (data.ok === false) {
                    throw new Ext.Error(dSS._("Could not get dSS version"), data.error);
                }
                Ext.get("dssVersion").update(data.result.version);

            } catch(error) {}
        },
        failure: function(response, options) {}
    });

    Ext.Ajax.request({
        url: "/json/system/time",
        disableCaching: true,
        scope: this,
        success: function(response, options) {
            try {
                var data = Ext.decode(response.responseText);
                if (data.ok === false) {
                    throw new Ext.Error(dSS._("Could not get dSS time"), data.error);
                }
                dSS.config.dSSTimeDiff = (Date.now() - (parseInt(data.result.time, 10) * 1000));
                dSS.time.update();

            } catch(error) {}
        },
        failure: function(response, options) {}
    });

};

Ext.onReady(function() {
    Ext.get('start').remove();

    Ext.Ajax.request({
        url: dSS.config.langPath,
        scope: this,
        method: "GET",
        disableCaching: true,
        success: function(response, options) {
            try {
                var data = Ext.util.JSON.decode(response.responseText);

                var params = {
                                'domain' : 'dss-installer',
                                'locale_data' : { 'dss-installer' : data }
                             };
                dSS.gt = new Gettext(params);
                dSS.overviewInit();
            } catch(err) {
                Ext.Msg.alert(dSS._("Error"), dSS._("Could not load language package") + ': ' + err);
                dSS.overviewInit();

            }
        },
        failure: function(response, options) {
            Ext.Msg.alert(dSS._("Error"), dSS._("Could not load language packge"));
            dSS.overviewInit();
        }
    });
});

